package org.dimdev.dimdoors.api;

import net.minecraft.class_2378;
import org.dimdev.dimdoors.block.door.data.condition.Condition;
import org.dimdev.dimdoors.pockets.generator.PocketGenerator;
import org.dimdev.dimdoors.pockets.modifier.Modifier;
import org.dimdev.dimdoors.pockets.virtual.ImplementedVirtualPocket;
import org.dimdev.dimdoors.rift.targets.VirtualTarget;
import org.dimdev.dimdoors.world.decay.DecayPredicate;
import org.dimdev.dimdoors.world.decay.DecayProcessor;
import org.dimdev.dimdoors.world.pocket.type.AbstractPocket;
import org.dimdev.dimdoors.world.pocket.type.addon.PocketAddon;

// TODO: javadocs for everything, refactoring
public interface DimensionalDoorsApi {
	default void registerVirtualTargetTypes(class_2378<VirtualTarget.VirtualTargetType<?>> registry) {
	}

	default void registerVirtualSingularPocketTypes(class_2378<ImplementedVirtualPocket.VirtualPocketType<?>> registry) {
	}

	default void registerModifierTypes(class_2378<Modifier.ModifierType<?>> registry) {
	}

	default void registerPocketGeneratorTypes(class_2378<PocketGenerator.PocketGeneratorType<?>> registry) {
	}

	default void registerAbstractPocketTypes(class_2378<AbstractPocket.AbstractPocketType<?>> registry) {
	}

	default void registerPocketAddonTypes(class_2378<PocketAddon.PocketAddonType<?>> registry) {
	}

	default void registerConditionTypes(class_2378<Condition.ConditionType<?>> registry) {
	}

	default void postInitialize() {}

	default void registerDecayProcessors(class_2378<DecayProcessor.DecayProcessorType<? extends DecayProcessor>> registry) {
	}

	default void registerDecayPredicates(class_2378<DecayPredicate.DecayPredicateType<? extends DecayPredicate>> registry) {
	}
}
