package org.dimdev.dimdoors.api.block;

import java.util.function.Consumer;
import net.minecraft.class_1271;
import net.minecraft.class_1297;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_3545;
import net.minecraft.class_3610;

/**
 * Only works in cases where {@link net.minecraft.class_4970#method_9559 AbstractBlock#getStateForNeighborUpdate} returns an air {@link class_2680}
 */
public interface CustomBreakBlock {
	class_1271<class_3545<class_2680, Consumer<class_2586>>> customBreakBlock(class_1937 world, class_2338 pos, class_2680 blockState, class_1297 breakingEntity);

	/*
	If this causes any issue mixin into FluidState instead.
	Also remember to remove the access wideners.
	 */
	class HackyFluidState extends class_3610 {
		private final class_2680 blockState;
		private final Consumer<class_2586> blockEntityConsumer;

		public HackyFluidState(class_2680 blockState, Consumer<class_2586> blockEntityConsumer) {
			super(blockState.method_26227().method_15772(), blockState.method_26227().method_11656(), blockState.method_26227().field_24740);
			this.blockState = blockState;
			this.blockEntityConsumer = blockEntityConsumer;
		}

		@Override
		public class_2680 method_15759() {
			return blockState;
		}

		public Consumer<class_2586> getBlockEntityConsumer() {
			return blockEntityConsumer;
		}
	}
}
