package org.dimdev.dimdoors.api.client;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1160;
import net.minecraft.class_2350;
import net.minecraft.class_4587;

@Environment(EnvType.CLIENT)
public enum DefaultTransformation implements Transformer {
	DOWN {
		@Override
		public void transform(class_4587 matrices) {

		}
	},
	UP {
		@Override
		public void transform(class_4587 matrices) {

		}
	},
	NORTH_DOOR {
		@Override
		public void transform(class_4587 matrices) {
			matrices.method_22904(0, 0, 0.81F);
		}
	},
	SOUTH_DOOR {
		@Override
		public void transform(class_4587 matrices) {
			matrices.method_22904(0, 0, 0.19F);
		}
	},
	WEST_DOOR {
		@Override
		public void transform(class_4587 matrices) {
			// TODO
			matrices.method_22907(class_1160.field_20704.method_23214(90.0F));
			matrices.method_22904(0, 0, -0.81F);
		}
	},
	EAST_DOOR {
		@Override
		public void transform(class_4587 matrices) {
			// TODO
			matrices.method_22907(class_1160.field_20704.method_23214(90.0F));
			matrices.method_22904(0, 0, -0.19F);
		}
	},
	NONE {
		@Override
		public void transform(class_4587 matrices) {
		}
	},
	DIMENSIONAL_PORTAL {
		@Override
		public void transform(class_4587 matrices) {
			matrices.method_22904(0, 0, 0.5F);
		}
	};

	private static final DefaultTransformation[] VALUES = values();

	public static DefaultTransformation fromDirection(class_2350 direction) {
		return VALUES[direction.ordinal()];
	}
}
