package org.dimdev.dimdoors.block;

import net.minecraft.block.*;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1750;
import net.minecraft.class_1799;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2237;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_2741;
import net.minecraft.class_2746;
import net.minecraft.class_3610;
import net.minecraft.class_3612;
import net.minecraft.class_3737;
import net.minecraft.class_3965;
import org.jetbrains.annotations.Nullable;

public abstract class WaterLoggableBlockWithEntity extends class_2237 implements class_3737 {
	public static final class_2746 WATERLOGGED = class_2741.field_12508;
	protected WaterLoggableBlockWithEntity(class_2251 settings) {
		super(settings);
		method_9590(this.field_10647.method_11664().method_11657(WATERLOGGED, false));
	}
	@Override
	protected void method_9515(class_2689.class_2690<class_2248, class_2680> builder) {
		super.method_9515(builder);
		builder.method_11667(WATERLOGGED);
	}

	@Override
	public class_1269 method_9534(class_2680 state, class_1937 world, class_2338 pos, class_1657 player, class_1268 hand, class_3965 hit) {
		class_1269 result = super.method_9534(state, world, pos, player, hand, hit);
		if (result.method_23665()) {
			world.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(world));
		}
		return result;
	}

	@Override
	public void method_9567(class_1937 world, class_2338 pos, class_2680 state, class_1309 placer, class_1799 itemStack) {
		class_2338 up = pos.method_10084();
		world.method_8652(up, state.method_11657(WATERLOGGED, world.method_8316(up).method_15772() == class_3612.field_15910), 3);
	}

	@Override
	public void method_9612(class_2680 state, class_1937 world, class_2338 pos, class_2248 block, class_2338 fromPos, boolean notify) {
		super.method_9612(state, world, pos, block, fromPos, notify);
		if (state.method_11654(WATERLOGGED)) {
			world.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(world));
		}
	}

	@Nullable
	@Override
	public class_2680 method_9605(class_1750 ctx) {
		boolean water = ctx.method_8045().method_8316(ctx.method_8037()).method_15772() == class_3612.field_15910;
		class_2680 state = super.method_9605(ctx);
		if (state == null) return null;
		if (water) return state.method_11657(WATERLOGGED, true);
		return state;
	}

	@Override
	public class_2680 method_9559(class_2680 state, class_2350 direction, class_2680 neighborState, class_1936 world, class_2338 pos, class_2338 neighborPos) {
		if (state.method_11654(WATERLOGGED)) {
			world.method_39281(pos, class_3612.field_15910, class_3612.field_15910.method_15789(world));
		}

		class_2680 newState = super.method_9559(state, direction, neighborState, world, pos, neighborPos);
		if (newState.method_26215() && state.method_26227().method_15772() == class_3612.field_15910) return class_2246.field_10382.method_9564();
		return newState;
	}

	@Override
	public class_3610 method_9545(class_2680 state) {
		return state.method_11654(WATERLOGGED) ? class_3612.field_15910.method_15729(false) : super.method_9545(state);
	}
}
