package org.dimdev.dimdoors.block.entity;

import org.apache.commons.lang3.ArrayUtils;
import org.dimdev.dimdoors.api.block.entity.MutableBlockEntityType;
import org.dimdev.dimdoors.block.ModBlocks;
import org.dimdev.dimdoors.block.door.data.DoorData;
import net.fabricmc.fabric.api.object.builder.v1.block.entity.FabricBlockEntityTypeBuilder;
import net.minecraft.class_2248;
import net.minecraft.class_2378;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

public class ModBlockEntityTypes {
	public static final class_2591<DetachedRiftBlockEntity> DETACHED_RIFT = register(
			"dimdoors:detached_rift",
			DetachedRiftBlockEntity::new,
			ModBlocks.DETACHED_RIFT);

	public static final MutableBlockEntityType<EntranceRiftBlockEntity> ENTRANCE_RIFT = registerMutable(
			"dimdoors:entrance_rift",
			EntranceRiftBlockEntity::new,
			ArrayUtils.add(DoorData.DOORS.toArray(new class_2248[0]), ModBlocks.DIMENSIONAL_PORTAL));


	private static <E extends class_2586> class_2591<E> register(String id, FabricBlockEntityTypeBuilder.Factory<E> factory, class_2248... blocks) {
		return class_2378.method_10226(class_2378.field_11137, id, FabricBlockEntityTypeBuilder.create(factory, blocks).build());
	}

	private static <E extends class_2586> MutableBlockEntityType<E> registerMutable(String id, MutableBlockEntityType.BlockEntityFactory<E> factory, class_2248... blocks) {
		return class_2378.method_10226(class_2378.field_11137, id, MutableBlockEntityType.Builder.create(factory, blocks).build());
	}

	public static void init() {
		//just loads the class
	}
}
