package org.dimdev.dimdoors.client;

import org.dimdev.dimdoors.api.client.DimensionalPortalRenderer;
import org.dimdev.dimdoors.block.entity.EntranceRiftBlockEntity;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_2561;
import net.minecraft.class_310;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_765;
import net.minecraft.class_827;
import org.dimdev.dimdoors.item.ModItems;
import org.dimdev.dimdoors.rift.targets.IdMarker;

@Environment(EnvType.CLIENT)
public class EntranceRiftBlockEntityRenderer implements class_827<EntranceRiftBlockEntity> {
	@Override
	public void render(EntranceRiftBlockEntity blockEntity, float tickDelta, class_4587 matrixStack, class_4597 vertexConsumerProvider, int light, int overlay) {
		if (class_310.method_1551().field_1724 != null)
			if (class_310.method_1551().field_1724.method_5998(class_1268.field_5808).method_31574(ModItems.RIFT_CONFIGURATION_TOOL))
				if (blockEntity.getData().getDestination() instanceof IdMarker idMarker) {
					matrixStack.method_22903();
					matrixStack.method_22904(0.5, 0.5, 0.5);

					class_310.method_1551().field_1772.method_30882(class_2561.method_30163(String.valueOf(idMarker.getId())), 0f, 0f, 0xffffffff, false, matrixStack.method_23760().method_23761(), vertexConsumerProvider, true, 0x000000, class_765.field_32767);

					matrixStack.method_22909();
				}

		DimensionalPortalRenderer.renderDimensionalPortal(matrixStack, vertexConsumerProvider, blockEntity.getTransformer(), tickDelta, light, overlay, blockEntity.isTall());
	}
}
