package org.dimdev.dimdoors.client;

import com.flowpowered.math.vector.VectorNi;
import com.mojang.blaze3d.systems.RenderSystem;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1921;
import net.minecraft.class_290;
import net.minecraft.class_293;
import net.minecraft.class_2960;
import net.minecraft.class_4668;
import net.minecraft.class_5819;
import net.minecraft.class_757;
import net.minecraft.client.render.*;
import org.dimdev.dimdoors.api.client.RenderLayerFactory;

import static org.lwjgl.opengl.GL11.GL_ONE_MINUS_DST_COLOR;
import static org.lwjgl.opengl.GL11.GL_ZERO;

@Environment(EnvType.CLIENT)
public class MyRenderLayer extends class_1921 {
    public static final class_2960 WARP_PATH = new class_2960("dimdoors:textures/other/warp.png");
    public static final VectorNi COLORLESS = new VectorNi(255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255);
    private static final class_2960 KEY_PATH = new class_2960("dimdoors:textures/other/keyhole.png");
    private static final class_2960 KEYHOLE_LIGHT = new class_2960("dimdoors:textures/other/keyhole_light.png");
    private static final class_5819 RANDOM = class_5819.method_43049(31100L);

    public MyRenderLayer(String string, class_293 vertexFormat, class_293.class_5596 drawMode, int j, boolean bl, boolean bl2, Runnable runnable, Runnable runnable2) {
        super(string, vertexFormat, drawMode, j, bl, bl2, runnable, runnable2);
    }

    public static class_1921 CRACK = RenderLayerFactory.create("crack",
			class_290.field_1576,
			class_293.class_5596.field_27382,
			256,
			false,
			false,
			class_4688.method_23598()
					.method_23603(field_21345)
					.method_23608(class_4668.field_21384)
					.method_34577(field_21378)
					.method_23615(new class_4685("crack_transparency",
							() -> {
								RenderSystem.enableBlend();
								RenderSystem.blendFunc(GL_ONE_MINUS_DST_COLOR, GL_ZERO);
							},
							() -> {
								RenderSystem.disableBlend();
								RenderSystem.defaultBlendFunc();
							})
					)
					.method_34578(class_4668.field_29442)
					.method_23617(false)
	);

    public static class_1921 TESSERACT = RenderLayerFactory.create("tesseract",
			class_290.field_20887,
			class_293.class_5596.field_27382,
			256,
			false,
			false,
			class_4688.method_23598()
					.method_23603(field_21345)
					.method_23608(class_4668.field_21384)
					.method_34577(new class_4683(DetachedRiftBlockEntityRenderer.TESSERACT_PATH,
							false,
							false)
					)
					.method_34578(class_4668.field_29439)
					.method_23617(false)
	);

	public static class_1921 getMonolith(class_2960 texture) {
		class_1921.class_4688 multiPhaseParameters = class_1921.class_4688.method_23598().method_34577(new class_4668.class_4683(texture, false, false)).method_34578(new class_5942(class_757::method_34508)).method_23615(class_4668.field_21370).method_23603(field_21345).method_23608(field_21383).method_23604(class_4668.field_21346).method_23611(field_21385).method_23617(false);
		return RenderLayerFactory.create("monolith", class_290.field_1580, class_293.class_5596.field_27382, 256, true, true, multiPhaseParameters);
	}
}
