package org.dimdev.dimdoors.client.wthit;

import mcp.mobius.waila.api.IBlockAccessor;
import mcp.mobius.waila.api.IBlockComponentProvider;
import mcp.mobius.waila.api.IPluginConfig;
import mcp.mobius.waila.api.ITooltip;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_2960;
import net.minecraft.class_5250;
import org.dimdev.dimdoors.block.entity.EntranceRiftBlockEntity;
import org.dimdev.dimdoors.rift.targets.VirtualTarget;

import java.util.Objects;

// FIXME: is not actually client sided
public enum EntranceRiftProvider implements IBlockComponentProvider {
	INSTANCE;

	private static final class_2960 ID = new class_2960("dimdoors", "entrance_rift_provider");

	@Override
	public void appendBody(ITooltip tooltip, IBlockAccessor accessor, IPluginConfig config) {
		if (!config.getBoolean(ID)) {
			return;
		}
		EntranceRiftBlockEntity blockEntity = ((EntranceRiftBlockEntity) accessor.getBlockEntity());
		VirtualTarget destination = Objects.requireNonNull(blockEntity).getDestination();
		if (destination != null) {
			class_2561 tKey = class_5250.method_43477(new class_2588(destination.getType().getTranslationKey()));
			class_2561 main = class_5250.method_43477(new class_2588("dimdoors.destination")).method_27693(": ").method_10852(tKey);
			tooltip.addLine(main);
		}
	}
}
