package org.dimdev.dimdoors.criteria;

import java.util.Objects;
import net.minecraft.class_195;
import net.minecraft.class_2048;
import net.minecraft.class_2248;
import net.minecraft.class_2378;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import net.minecraft.class_3222;
import net.minecraft.class_4558;
import net.minecraft.class_5257;
import net.minecraft.class_5267;
import net.minecraft.class_6862;
import com.google.gson.JsonObject;

public class TagBlockBreakCriteria extends class_4558<TagBlockBreakCriteria.Conditions> {
	public static final class_2960 ID = new class_2960("dimdoors", "tag_block_break");

	@Override
	protected Conditions method_27854(JsonObject obj, class_2048.class_5258 playerPredicate, class_5257 predicateDeserializer) {
		return new Conditions(playerPredicate, class_6862.method_40092(class_2378.field_25105, class_2960.method_12829(obj.get("tag").getAsString())));
	}

	public void trigger(class_3222 player, class_2680 block) {
		this.method_22510(player, c -> block.method_26164(c.getBlockTag()));
	}

	@Override
	public class_2960 method_794() {
		return ID;
	}

	public static class Conditions extends class_195 {
		private final class_6862<class_2248> blockTag;

		public Conditions(class_2048.class_5258 playerPredicate, class_6862<class_2248> blockTag) {
			super(ID, playerPredicate);
			this.blockTag = Objects.requireNonNull(blockTag);
		}

		@Override
		public JsonObject method_807(class_5267 predicateSerializer) {
			JsonObject json = new JsonObject();
			json.addProperty("tag", blockTag.comp_327().toString());
			return super.method_807(predicateSerializer);
		}

		public class_6862<class_2248> getBlockTag() {
			return blockTag;
		}
	}
}
