package org.dimdev.dimdoors.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataGenerator;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricModelProvider;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_4910;
import net.minecraft.class_4915;
import net.minecraft.class_4943;
import net.minecraft.class_4944;
import org.dimdev.dimdoors.block.ModBlocks;

public class BlockStateProvider extends FabricModelProvider {
	public BlockStateProvider(FabricDataGenerator dataGenerator) {
		super(dataGenerator);
	}

	@Override
	public void generateBlockStateModels(class_4910 generator) {
		generator.method_25658(ModBlocks.GOLD_DOOR);
		generator.method_25658(ModBlocks.STONE_DOOR);
		generator.method_25658(ModBlocks.QUARTZ_DOOR);
		registerDoor(generator, class_2378.field_11146.method_10223(new class_2960("dimdoors", "iron_dimensional_door")), class_2246.field_9973);
		registerDoor(generator, class_2378.field_11146.method_10223(new class_2960("dimdoors", "gold_dimensional_door")), ModBlocks.GOLD_DOOR);
		registerDoor(generator, class_2378.field_11146.method_10223(new class_2960("dimdoors", "quartz_dimensional_door")), ModBlocks.QUARTZ_DOOR);
		registerDoor(generator, class_2378.field_11146.method_10223(new class_2960("dimdoors", "oak_dimensional_door")), class_2246.field_10149);
//		registerDoor(generator, Registry.BLOCK.get(new Identifier("dimdoors", "dungeon_door")), ModBlocks.STONE_DOOR);
	}

	public void registerDoor(class_4910 generator, class_2248 doorBlock, class_2248 textureSource) {
		class_4944 textureMap = class_4944.method_25900(textureSource);
		class_2960 identifier = class_4943.field_38016.method_25846(doorBlock, textureMap, generator.field_22831);
		class_2960 identifier2 = class_4943.field_38017.method_25846(doorBlock, textureMap, generator.field_22831);
		class_2960 identifier3 = class_4943.field_38018.method_25846(doorBlock, textureMap, generator.field_22831);
		class_2960 identifier4 = class_4943.field_38019.method_25846(doorBlock, textureMap, generator.field_22831);
		class_2960 identifier5 = class_4943.field_38020.method_25846(doorBlock, textureMap, generator.field_22831);
		class_2960 identifier6 = class_4943.field_38021.method_25846(doorBlock, textureMap, generator.field_22831);
		class_2960 identifier7 = class_4943.field_38022.method_25846(doorBlock, textureMap, generator.field_22831);
		class_2960 identifier8 = class_4943.field_38023.method_25846(doorBlock, textureMap, generator.field_22831);
		generator.method_25537(doorBlock.method_8389());
		generator.field_22830.accept(class_4910.method_25609(doorBlock, identifier, identifier2, identifier3, identifier4, identifier5, identifier6, identifier7, identifier8));
	}

	@Override
	public void generateItemModels(class_4915 itemModelGenerator) {

	}
}
