package org.dimdev.dimdoors.datagen;

import java.io.IOException;

import net.fabricmc.fabric.api.datagen.v1.FabricDataGenerator;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricBlockLootTableProvider;
import net.minecraft.class_182;
import net.minecraft.class_1893;
import net.minecraft.class_2248;
import net.minecraft.class_77;
import org.dimdev.dimdoors.block.ModBlocks;
import org.dimdev.dimdoors.item.ModItems;

public class LootTableProvider extends FabricBlockLootTableProvider {

	public LootTableProvider(FabricDataGenerator dataGenerator) {
		super(dataGenerator);
	}

	@Override
	protected void generateBlockLootTables() {
		for (class_2248 block : ModBlocks.FABRIC_BLOCKS.values()) {
			this.method_16262(block);
		}
		this.method_16262(ModBlocks.GOLD_DOOR);
		this.method_16262(ModBlocks.QUARTZ_DOOR);
//		this.addDropWithSilkTouch(ModBlocks.OAK_DIMENSIONAL_DOOR);
//		this.addDropWithSilkTouch(ModBlocks.IRON_DIMENSIONAL_DOOR);
//		this.addDropWithSilkTouch(ModBlocks.GOLD_DIMENSIONAL_DOOR);
//		this.addDropWithSilkTouch(ModBlocks.QUARTZ_DIMENSIONAL_DOOR);
		this.method_16262(ModBlocks.OAK_DIMENSIONAL_TRAPDOOR);
		this.method_16262(ModBlocks.MARKING_PLATE);

		this.method_16293(ModBlocks.SOLID_STATIC, (blockx) -> method_10377(blockx, ModItems.INFRANGIBLE_FIBER));

		this.method_16293(ModBlocks.UNRAVELLED_FABRIC, (blockx) -> method_10397(blockx, method_10392(blockx, class_77.method_411(ModItems.FRAYED_FILAMENT).method_421(class_182.method_800(class_1893.field_9130, 0.1F, 0.14285715F, 0.25F, 1.0F)).method_417(class_77.method_411(blockx)))));
	}

	@Override
	public String method_10321() {
		return "Dimdoors Loot Tables";
	}
}
