package org.dimdev.dimdoors.entity.limbo;

import net.minecraft.class_1282;
import net.minecraft.class_1657;
import net.minecraft.class_2561;
import net.minecraft.class_2588;
import net.minecraft.class_5250;
import net.minecraft.server.MinecraftServer;

public abstract class LimboEntranceSource {
	public abstract class_2561 getMessage(class_1657 player);

	public void broadcast(class_1657 player, MinecraftServer server) {
		server.method_3760().method_43514(this.getMessage(player), false);
	}

	public static LimboDeathEntranceSource ofDamageSource(class_1282 source) {
		return new LimboDeathEntranceSource(source);
	}

	public static class LimboDeathEntranceSource extends LimboEntranceSource {
		private final class_1282 damageSource;

		private LimboDeathEntranceSource(class_1282 damageSource) {
			this.damageSource = damageSource;
		}

		@Override
		public class_2561 getMessage(class_1657 player) {
			class_2588 message = (class_2588) this.damageSource.method_5506(player).method_10851();
			return class_5250.method_43477(new class_2588("limbo." + message.method_11022(), message.method_11023()));
		}
	}
}
