package org.dimdev.dimdoors.fluid;

import org.dimdev.dimdoors.block.ModBlocks;
import org.dimdev.dimdoors.item.ModItems;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1792;
import net.minecraft.class_1922;
import net.minecraft.class_1936;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2404;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_3486;
import net.minecraft.class_3609;
import net.minecraft.class_3610;
import net.minecraft.class_3611;
import net.minecraft.class_4538;
import net.minecraft.class_5819;

public abstract class EternalFluid extends class_3609 {
	@Override
	public class_3611 method_15750() {
		return ModFluids.FLOWING_ETERNAL_FLUID;
	}

	@Override
	public class_3611 method_15751() {
		return ModFluids.ETERNAL_FLUID;
	}

	@Override
	public class_1792 method_15774() {
		return ModItems.ETERNAL_FLUID_BUCKET;
	}

	@Override
	@Environment(EnvType.CLIENT)
	public void method_15776(class_1937 world, class_2338 blockPos, class_3610 fluidState, class_5819 random) {

	}

	@Override
	public void method_15792(class_1937 world, class_2338 blockPos, class_3610 fluidState, class_5819 random) {

	}

	@Override
	protected void method_15730(class_1936 iWorld, class_2338 blockPos, class_2680 blockState) {

	}

	@Override
	public int method_15733(class_4538 worldView) {
		return worldView.method_8597().comp_644() ? 4 : 2;
	}

	@Override
	public class_2680 method_15790(class_3610 fluidState) {
		return ModBlocks.ETERNAL_FLUID.method_9564().method_11657(class_2404.field_11278, method_15741(fluidState));
	}

	@Override
	public boolean method_15780(class_3611 fluid) {
		return fluid == ModFluids.ETERNAL_FLUID || fluid == ModFluids.FLOWING_ETERNAL_FLUID;
	}

	@Override
	public int method_15739(class_4538 worldView) {
		return worldView.method_8597().comp_644() ? 1 : 2;
	}

	@Override
	public boolean method_15777(class_3610 fluidState, class_1922 blockView, class_2338 blockPos, class_3611 fluid, class_2350 direction) {
		return fluidState.method_15763(blockView, blockPos) >= 0.44444445F && fluid.method_15791(class_3486.field_15517);
	}

	@Override
	public int method_15789(class_4538 worldView) {
		return worldView.method_8597().comp_644() ? 10 : 30;
	}

	@Override
	public int method_15753(class_1937 world, class_2338 blockPos, class_3610 fluidState, class_3610 fluidState2) {
		int tickDelay = this.method_15789(world);

		if (!fluidState.method_15769() && !fluidState2.method_15769() && !fluidState.method_11654(field_15902) && !fluidState2.method_11654(field_15902) && fluidState2.method_15763(world, blockPos) > fluidState.method_15763(world, blockPos) && world.method_8409().method_43048(4) != 0) {
			tickDelay *= 4;
		}

		return tickDelay;
	}

	@Override
	protected boolean method_15737() {
		return false;
	}

	@Override
	protected void method_15745(class_1936 world, class_2338 pos, class_2680 blockState, class_2350 direction, class_3610 fluidState) {
		if (direction == class_2350.field_11033) {
			if (world.method_8316(pos).method_15767(class_3486.field_15517)) {
				if (blockState.method_26204() instanceof class_2404) {
					world.method_8652(pos, ModBlocks.BLACK_ANCIENT_FABRIC.method_9564(), 3);
				}

				return;
			}
		}

		super.method_15745(world, pos, blockState, direction, fluidState);
	}

	@Override
	protected boolean method_15795() {
		return true;
	}

	@Override
	protected float method_15784() {
		return 100000;
	}

	public static class Flowing extends EternalFluid {
		@Override
		protected void method_15775(class_2689.class_2690<class_3611, class_3610> builder) {
			super.method_15775(builder);
			builder.method_11667(field_15900);
		}

		@Override
		public int method_15779(class_3610 fluidState) {
			return fluidState.method_11654(field_15900);
		}

		@Override
		public boolean method_15793(class_3610 fluidState) {
			return false;
		}
	}

	public static class Still extends EternalFluid {
		@Override
		public int method_15779(class_3610 fluidState) {
			return 8;
		}

		@Override
		public boolean method_15793(class_3610 fluidState) {
			return true;
		}
	}
}
