package org.dimdev.dimdoors.item;

import static org.dimdev.dimdoors.api.util.math.MathUtil.entityEulerAngle;

import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1271;
import net.minecraft.class_1297;
import net.minecraft.class_1657;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_239;
import net.minecraft.class_3222;
import net.minecraft.class_3966;
import org.dimdev.dimdoors.api.util.TeleportUtil;
import org.dimdev.dimdoors.block.ModBlocks;
import org.dimdev.dimdoors.rift.targets.LimboTarget;
import org.dimdev.dimdoors.sound.ModSoundEvents;
import org.dimdev.dimdoors.world.ModDimensions;
import org.dimdev.dimdoors.world.pocket.VirtualLocation;

public class DimensionalEraserItem extends class_1792 {
	public DimensionalEraserItem(class_1793 settings) {
		super(settings);
	}

	@Override
	public class_1271<class_1799> method_7836(class_1937 world, class_1657 player, class_1268 hand) {
		class_1799 stack = player.method_5998(hand);

		class_239 hit = RaycastHelper.raycast(player, RaycastHelper.REACH_DISTANCE, 1.0F, a -> !(a instanceof class_1657));

		if (hit != null && hit.method_17783() == class_239.class_240.field_1331) {
			if(((class_3966) hit).method_17782() instanceof class_3222) {
				class_2338 teleportPos = ((class_3966) hit).method_17782().method_24515();
				while(ModDimensions.LIMBO_DIMENSION.method_8320(VirtualLocation.getTopPos(ModDimensions.LIMBO_DIMENSION, teleportPos.method_10263(), teleportPos.method_10260())).method_26204() == ModBlocks.ETERNAL_FLUID) {
					teleportPos = teleportPos.method_10069(1, 0, 1);
				}
				TeleportUtil.teleport(((class_3966) hit).method_17782(), ModDimensions.LIMBO_DIMENSION, teleportPos.method_33096(255), entityEulerAngle(((class_3966) hit).method_17782()), ((class_3966) hit).method_17782().method_18798());
			}

			((class_3966) hit).method_17782().method_5650(class_1297.class_5529.field_26998);
			player.method_5783(ModSoundEvents.BLOOP, 1.0f, 1.0f);
			return new class_1271<>(class_1269.field_5812, stack);
		}

		return new class_1271<>(class_1269.field_5814, stack);
	}
}
