package org.dimdev.dimdoors.item;

import java.util.function.Predicate;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1675;
import net.minecraft.class_1922;
import net.minecraft.class_238;
import net.minecraft.class_239;
import net.minecraft.class_243;
import net.minecraft.class_3965;
import net.minecraft.class_3966;
import org.dimdev.dimdoors.block.entity.DetachedRiftBlockEntity;
import org.dimdev.dimdoors.block.entity.RiftBlockEntity;

public final class RaycastHelper {
	public static final int REACH_DISTANCE = 5;

	public static boolean hitsDetachedRift(class_239 hit, class_1922 world) {
		return hit != null && hit.method_17783() == class_239.class_240.field_1332 && world.method_8321(((class_3965) hit).method_17777()) instanceof DetachedRiftBlockEntity;
	}

	public static boolean hitsRift(class_239 hit, class_1922 world) {
		return hit != null && hit.method_17783() == class_239.class_240.field_1332 && world.method_8321(((class_3965) hit).method_17777()) instanceof RiftBlockEntity;
	}

	public static boolean hitsLivingEntity(class_239 hit) {
		return hit != null && hit.method_17783() == class_239.class_240.field_1331 && ((class_3966) hit).method_17782() instanceof class_1309;
	}

	public static class_239 raycast(class_1297 entity, double maxDistance, float tickDelta, Predicate<class_1297> predicate) {
		class_243 vec3d = entity.method_5836(tickDelta);
		class_243 vec3d2 = entity.method_5828(tickDelta);
		class_243 vec3d3 = vec3d.method_1031(vec3d2.field_1352 * maxDistance, vec3d2.field_1351 * maxDistance, vec3d2.field_1350 * maxDistance);
		class_238 box = entity.method_5829().method_18804(vec3d2.method_1021(maxDistance)).method_1009(1.0D, 1.0D, 1.0D);
		return class_1675.method_18075(entity, vec3d, vec3d3, box, predicate, maxDistance);
	}
}
