package org.dimdev.dimdoors.listener.pocket;

import net.fabricmc.fabric.api.event.player.AttackBlockCallback;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import java.util.List;

public class PocketAttackBlockCallbackListener implements AttackBlockCallback {
	@Override
	public class_1269 interact(class_1657 player, class_1937 world, class_1268 hand, class_2338 pos, class_2350 direction) {
		List<AttackBlockCallback> applicableAddons;
		if (world.field_9236) applicableAddons = PocketListenerUtil.applicableAddonsClient(AttackBlockCallback.class, world, pos);
		else applicableAddons = PocketListenerUtil.applicableAddons(AttackBlockCallback.class, world, pos);

		class_1269 result;
		for (AttackBlockCallback listener : applicableAddons) {
			result = listener.interact(player, world, hand, pos, direction);
			if (result != class_1269.field_5811) return result;
		}
		return class_1269.field_5811;
	}
}
