package org.dimdev.dimdoors.mixin;

import net.minecraft.class_1792;
import org.dimdev.dimdoors.item.ItemExtensions;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_1792.class)
public class ItemMixin implements ItemExtensions {
	@Unique
	private class_1792.class_1793 settings;

	@Inject(method = "<init>", at = @At("TAIL"))
	public void cacheSettings(class_1792.class_1793 settings, CallbackInfo ci) {
		this.settings = settings;
	}

	@Override
	public class_1792.class_1793 dimdoors_getSettings() {
		return settings;
	}

	@Mixin(class_1792.class_1793.class)
	public static class SettingsMixin implements ItemExtensions.SettingsExtensions {
		@Override
		public class_1792.class_1793 clone() {
			try {
				return (class_1792.class_1793) super.clone();
			} catch (CloneNotSupportedException e) {
				throw new AssertionError(e); // Cant happen, we are Cloneable
			}
		}
	}
}
