package org.dimdev.dimdoors.mixin.client;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_310;
import net.minecraft.class_634;
import org.dimdev.dimdoors.network.client.ClientPacketHandler;
import org.dimdev.dimdoors.network.client.ExtendedClientPlayNetworkHandler;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.Unique;

@Environment(EnvType.CLIENT)
@Mixin(class_634.class)
public class ExtendedClientPlayNetworkHandlerMixin implements ExtendedClientPlayNetworkHandler {
	@Final @Shadow
	private class_310 client;
	private final ClientPacketHandler dimdoors_PacketHandler = new ClientPacketHandler((class_634) (Object) this);

	@Unique
	public ClientPacketHandler getDimDoorsPacketHandler() {
		return dimdoors_PacketHandler;
	}

	@Unique
	public class_310 dimdoorsGetClient() {
		return client;
	}
}
