package org.dimdev.dimdoors.mixin.client;

import java.io.IOException;
import java.util.List;
import java.util.function.Consumer;

import org.dimdev.dimdoors.client.ModShaders;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import com.mojang.datafixers.util.Pair;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_290;
import net.minecraft.class_293;
import net.minecraft.class_3300;
import net.minecraft.class_5912;
import net.minecraft.class_5944;
import net.minecraft.class_757;
import org.spongepowered.asm.mixin.injection.callback.LocalCapture;

@Environment(EnvType.CLIENT)
@Mixin(class_757.class)
public abstract class GameRendererMixin {
	@Shadow
	protected abstract class_5944 loadShader(class_5912 arg, String string, class_293 vertexFormat) throws IOException;

	@Inject(method = "loadShaders", at = @At(value = "INVOKE", shift = At.Shift.AFTER, ordinal = 1, target = "java/util/List.add(Ljava/lang/Object;)Z"), locals = LocalCapture.CAPTURE_FAILSOFT)
	public void onReload(class_3300 manager, CallbackInfo ci, List list, List list2) throws IOException {
		list2.add(Pair.of(new class_5944(manager, "dimensional_portal", class_290.field_1592), (Consumer<class_5944>) ModShaders::setDimensionalPortal));
	}
}
