package org.dimdev.dimdoors.network.packet.c2s;

import org.dimdev.dimdoors.network.ServerPacketListener;
import org.dimdev.dimdoors.network.SimplePacket;

import java.io.IOException;
import net.minecraft.class_2540;
import net.minecraft.class_2960;

public class NetworkHandlerInitializedC2SPacket implements SimplePacket<ServerPacketListener> {
	public static final class_2960 ID = new class_2960("dimdoors", "network_handler_initialized");

	@Override
	public SimplePacket<ServerPacketListener> read(class_2540 buf) throws IOException {
		return this;
	}

	@Override
	public class_2540 write(class_2540 buf) throws IOException {
		return buf;
	}

	@Override
	public void apply(ServerPacketListener listener) {
		listener.onNetworkHandlerInitialized(this);
	}

	@Override
	public class_2960 channelId() {
		return ID;
	}
}
