package org.dimdev.dimdoors.network.packet.s2c;

import java.io.IOException;

import org.dimdev.dimdoors.network.SimplePacket;
import org.dimdev.dimdoors.network.client.ClientPacketListener;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2540;
import net.minecraft.class_2960;

public class MonolithAggroParticlesPacket implements SimplePacket<ClientPacketListener> {
	public static final class_2960 ID = new class_2960("dimdoors", "monolith_aggro_particles");

	private int aggro;

	@Environment(EnvType.CLIENT)
	public MonolithAggroParticlesPacket() {
	}

	public MonolithAggroParticlesPacket(int aggro) {
		this.aggro = aggro;
	}

	@Override
	public SimplePacket<ClientPacketListener> read(class_2540 buf) throws IOException {
		return new MonolithAggroParticlesPacket(buf.method_10816());
	}

	@Override
	public class_2540 write(class_2540 buf) throws IOException {
		buf.method_10804(aggro);
		return buf;
	}

	@Override
	public void apply(ClientPacketListener listener) {
		listener.onMonolithAggroParticles(this);
	}

	@Override
	public class_2960 channelId() {
		return ID;
	}

	public int getAggro() {
		return aggro;
	}
}
