package org.dimdev.dimdoors.particle;

import org.dimdev.dimdoors.particle.client.LimboAshParticle;
import org.dimdev.dimdoors.particle.client.MonolithParticle;
import org.dimdev.dimdoors.particle.client.RiftParticle;
import org.dimdev.dimdoors.particle.client.RiftParticleEffect;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.client.particle.v1.ParticleFactoryRegistry;
import net.fabricmc.fabric.api.particle.v1.FabricParticleTypes;
import net.minecraft.class_2378;
import net.minecraft.class_2396;
import net.minecraft.class_2400;
import net.minecraft.class_2960;

public class ModParticleTypes {
	public static final class_2400 MONOLITH = FabricParticleTypes.simple(true);
	public static final class_2396<RiftParticleEffect> RIFT = new RiftParticleType();
	public static final class_2400 LIMBO_ASH = FabricParticleTypes.simple(false);

	public static void init() {
		class_2378.method_10230(class_2378.field_11141, new class_2960("dimdoors", "monolith"), MONOLITH);
		class_2378.method_10230(class_2378.field_11141, new class_2960("dimdoors", "rift"), RIFT);
		class_2378.method_10230(class_2378.field_11141, new class_2960("dimdoors", "limbo_ash"), LIMBO_ASH);
	}

	@Environment(EnvType.CLIENT)
	public static void initClient() {
		ParticleFactoryRegistry.getInstance().register(MONOLITH, new MonolithParticle.Factory());
		ParticleFactoryRegistry.getInstance().register(RIFT, RiftParticle.Factory::new);
		ParticleFactoryRegistry.getInstance().register(LIMBO_ASH, LimboAshParticle.Factory::new);
	}
}
