package org.dimdev.dimdoors.particle.client;

import org.dimdev.dimdoors.client.MonolithModel;
import org.dimdev.dimdoors.client.MonolithRenderer;
import org.jetbrains.annotations.Nullable;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1160;
import net.minecraft.class_2400;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_3999;
import net.minecraft.class_4184;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_4597;
import net.minecraft.class_4608;
import net.minecraft.class_638;
import net.minecraft.class_703;
import net.minecraft.class_707;

@Environment(EnvType.CLIENT)
public class MonolithParticle extends class_703 {

	public MonolithParticle(class_638 world, double x, double y, double z) {
		super(world, x, y, z);
		this.field_3847 = 30;
	}

	@Override
	public void method_3074(class_4588 vertexConsumer, class_4184 camera, float tickDelta) {
		float delta = ((float)this.field_3866 + tickDelta) / (float)this.field_3847;
		class_4587 matrices = new class_4587();
		matrices.method_22907(camera.method_23767());
		matrices.method_22907(class_1160.field_20703.method_23214(150.0F * delta - 60.0F));
		matrices.method_22905(-1.0F, -1.0F, 1.0F);
		matrices.method_22904(0.0D, -1.1009999513626099D, 1.5D);
		class_4597.class_4598 immediate = class_310.method_1551().method_22940().method_23000();
		class_4588 vertexConsumer2 = immediate.getBuffer(MonolithRenderer.getInstance().method_23500(new class_2960("dimdoors:textures/mob/monolith/monolith14.png")));
		MonolithRenderer.getInstance().method_2828(matrices, vertexConsumer2, 0xf000f0, class_4608.field_21444, 1.0F, 1.0F, 1.0F, 1.0F);
		immediate.method_22993();
	}

	@Override
	public class_3999 method_18122() {
		return class_3999.field_17831;
	}

	public static class Factory implements class_707<class_2400> {
		@Nullable
		@Override
		public class_703 createParticle(class_2400 parameters, class_638 world, double x, double y, double z, double velocityX, double velocityY, double velocityZ) {
			return new MonolithParticle(world, x, y, z);
		}
	}
}
