package org.dimdev.dimdoors.particle.client;

import net.minecraft.class_3999;
import net.minecraft.class_4002;
import net.minecraft.class_638;
import net.minecraft.class_703;
import net.minecraft.class_707;
import net.minecraft.class_708;
import org.dimdev.dimdoors.particle.RiftParticleType;

public class RiftParticle extends class_708 {
    public RiftParticle(class_638 world, double x, double y, double z, double velocityX, double velocityY, double velocityZ, float color, int ageSpread, class_4002 spriteProvider) {
        super(world, x, y, z, spriteProvider, 0);
        this.field_3852 = velocityX;
        this.field_3869 = velocityY;
        this.field_3850 = velocityZ;

        this.field_17867 *= 0.55f;
        this.field_3847 = ageSpread - ageSpread / 2 + this.field_3840.method_43048(2000);

        this.method_3084(color, color, color);
        this.method_18142(spriteProvider);
    }

    @Override
    public class_3999 method_18122() {
        return super.method_18122();
    }

    public static class Factory implements class_707<RiftParticleEffect> {
        private final class_4002 spriteProvider;

        public Factory(class_4002 spriteProvider) {
            this.spriteProvider = spriteProvider;
        }

        public class_703 createParticle(RiftParticleEffect riftParticleEffect, class_638 clientWorld, double x, double y, double z, double velocityX, double velocityY, double velocityZ) {
            return new RiftParticle(clientWorld, x, y, z, velocityX, velocityY, velocityZ, riftParticleEffect.getColor(), riftParticleEffect.getAverageAge(), this.spriteProvider);
        }
    }
}
