package org.dimdev.dimdoors.pockets.virtual;

import net.minecraft.class_2487;
import net.minecraft.class_2519;
import net.minecraft.class_2520;

public abstract class AbstractVirtualPocket implements ImplementedVirtualPocket {
	private String resourceKey = null;

	@Override
	public void setResourceKey(String resourceKey) {
		this.resourceKey = resourceKey;
	}

	@Override
	public String getResourceKey() {
		return resourceKey;
	}

	@Override
	public class_2520 toNbt(class_2487 nbt, boolean allowReference) {
		if (allowReference && this.getResourceKey() != null) {
			return class_2519.method_23256(this.getResourceKey());
		}
		return toNbtInternal(nbt, allowReference);
	}

	// utility so the first part of toNbt can be extracted into default method
	// at this point we know for a fact, that we need to serialize into the NbtCompound
	// overwrite in subclass
	protected class_2487 toNbtInternal(class_2487 nbt, boolean allowReference) {
		return this.getType().toNbt(nbt);
	}
}
