package org.dimdev.dimdoors.rift.targets;

import com.mojang.serialization.Codec;
import net.minecraft.class_2487;
import org.dimdev.dimdoors.api.util.Location;

public class GlobalReference extends RiftReference {
	public static Codec<GlobalReference> CODEC = Location.CODEC.fieldOf("location").xmap(GlobalReference::new, GlobalReference::getReferencedLocation).codec();

	private final Location target;

	public GlobalReference(Location target) {
		this.target = target;
	}

	@Override
	public Location getReferencedLocation() {
		return this.target;
	}

	@Override
	public VirtualTargetType<? extends VirtualTarget> getType() {
		return VirtualTargetType.GLOBAL;
	}

	public static class_2487 toNbt(GlobalReference virtualTarget) {
		class_2487 nbt = new class_2487();
		nbt.method_10566("target", Location.toNbt(virtualTarget.getReferencedLocation()));
		return nbt;
	}

	public static GlobalReference fromNbt(class_2487 nbt) {
		return new GlobalReference(Location.fromNbt(nbt.method_10562("target")));
	}
}
