package org.dimdev.dimdoors.rift.targets;

import net.minecraft.class_1297;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import net.minecraft.class_2487;
import net.minecraft.class_2561;
import org.dimdev.dimdoors.api.rift.target.EntityTarget;
import org.dimdev.dimdoors.api.util.EntityUtils;

public class IdMarker extends VirtualTarget implements EntityTarget {
	private final int id;

	public IdMarker(int id) {
		this.id = id;
	}

	@Override
	public VirtualTargetType<? extends VirtualTarget> getType() {
		return VirtualTargetType.ID_MARKER;
	}

	public static class_2487 toNbt(IdMarker target) {
		class_2487 nbt = new class_2487();
		nbt.method_10569("id", target.id);
		return nbt;
	}

	public static IdMarker fromNbt(class_2487 nbt) {
		return new IdMarker(nbt.method_10550("id"));
	}

	public int getId() {
		return this.id;
	}

	@Override
	public boolean receiveEntity(class_1297 entity, class_243 relativePos, class_2379 relativeAngle, class_243 relativeVelocity) {
		EntityUtils.chat(entity, class_2561.method_30163("This rift is configured for pocket dungeons. Its id is " + this.id));
		return false;
	}
}
