package org.dimdev.dimdoors.rift.targets;

import com.mojang.serialization.Codec;
import com.terraformersmc.modmenu.util.mod.Mod;
import net.minecraft.class_1297;
import net.minecraft.class_2338;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import org.dimdev.dimdoors.api.rift.target.EntityTarget;
import org.dimdev.dimdoors.api.util.TeleportUtil;
import org.dimdev.dimdoors.block.ModBlocks;
import org.dimdev.dimdoors.world.ModDimensions;
import org.dimdev.dimdoors.world.pocket.VirtualLocation;

public class LimboTarget extends VirtualTarget implements EntityTarget {
	public static final LimboTarget INSTANCE = new LimboTarget();
	public static final Codec<LimboTarget> CODEC = Codec.unit(INSTANCE);

	private LimboTarget() {
	}

	@Override
	public boolean receiveEntity(class_1297 entity, class_243 relativePos, class_2379 relativeAngle, class_243 relativeVelocity) {
		class_2338 teleportPos = entity.method_24515();
		while(ModDimensions.LIMBO_DIMENSION.method_8320(VirtualLocation.getTopPos(ModDimensions.LIMBO_DIMENSION, teleportPos.method_10263(), teleportPos.method_10260())).method_26204() == ModBlocks.ETERNAL_FLUID) {
			teleportPos = teleportPos.method_10069(1, 0, 1);
		}
		TeleportUtil.teleport(entity, ModDimensions.LIMBO_DIMENSION, teleportPos.method_33096(255), relativeAngle, relativeVelocity);
		return true;
	}

	@Override
	public VirtualTargetType<? extends VirtualTarget> getType() {
		return VirtualTargetType.LIMBO;
	}
}
