package org.dimdev.dimdoors.util.schematic;

import java.util.Optional;
import java.util.function.Predicate;
import net.minecraft.class_1297;
import net.minecraft.class_1922;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2591;
import net.minecraft.class_2680;
import net.minecraft.class_2902;
import net.minecraft.class_3610;
import net.minecraft.class_3747;
import net.minecraft.class_5281;
import org.dimdev.dimdoors.api.util.BlockPlacementType;
import org.jetbrains.annotations.Nullable;

public class WorldlyBlockSample implements class_1922, class_3747 {
	private final RelativeBlockSample relativeBlockSample;
	private final class_5281 world;

	public WorldlyBlockSample(RelativeBlockSample relativeBlockSample, class_5281 world) {
		this.relativeBlockSample = relativeBlockSample;
		this.world = world;
	}

	public void place(class_2338 origin, boolean biomes) {
		this.relativeBlockSample.place(origin, this.world, BlockPlacementType.SECTION_NO_UPDATE, biomes);
	}

	@Nullable
	@Override
	public class_2586 method_8321(class_2338 pos) {
		return this.relativeBlockSample.method_8321(pos);
	}

	@Override
	public <T extends class_2586> Optional<T> method_35230(class_2338 pos, class_2591<T> type) {
		 return Optional.ofNullable(type.method_24182(this, pos));
	}

	@Override
	public class_2680 method_8320(class_2338 pos) {
		return this.relativeBlockSample.method_8320(pos);
	}

	@Override
	public class_3610 method_8316(class_2338 pos) {
		return this.relativeBlockSample.method_8316(pos);
	}

	@Override
	public boolean method_30092(class_2338 pos, class_2680 state, int flags, int maxUpdateDepth) {
		return this.relativeBlockSample.method_30092(pos, state, flags, maxUpdateDepth);
	}

	@Override
	public boolean method_8650(class_2338 pos, boolean move) {
		return this.relativeBlockSample.method_8650(pos, move);
	}

	@Override
	public boolean method_30093(class_2338 pos, boolean drop, @Nullable class_1297 breakingEntity, int maxUpdateDepth) {
		return this.relativeBlockSample.method_30093(pos, drop, breakingEntity, maxUpdateDepth);
	}

	@Override
	public boolean method_16358(class_2338 pos, Predicate<class_2680> state) {
		return state.test(this.method_8320(pos));
	}

	@Override
	public boolean method_35237(class_2338 pos, Predicate<class_3610> state) {
		throw new RuntimeException("Method Implementation missing!"); // FIXME
	}

	@Override
	public class_2338 method_8598(class_2902.class_2903 type, class_2338 blockPos) {
		throw new RuntimeException("Method Implementation missing!"); // FIXME
	}

	@Override
	public int method_31605() {
		return this.relativeBlockSample.method_31605();
	}

	@Override
	public int method_31607() {
		return this.relativeBlockSample.method_31607();
	}
}
