package org.dimdev.dimdoors.world.level.registry;

import com.mojang.datafixers.DSL;
import com.mojang.datafixers.DataFixer;
import com.mojang.datafixers.DataFixerBuilder;
import com.mojang.datafixers.schemas.Schema;
import com.mojang.serialization.Dynamic;
import org.dimdev.dimdoors.world.level.registry.schema.Schema1;

import java.util.function.BiFunction;
import net.minecraft.class_156;
import net.minecraft.class_2487;
import net.minecraft.class_2509;

public class RiftSchemas {
	public static final DSL.TypeReference RIFT_DATA_TYPE_REF = () -> "rift_data";
	public static final int RIFT_DATA_VERSION = DimensionalRegistry.RIFT_DATA_VERSION;
	public static final BiFunction<Integer, Schema, Schema> EMPTY = Schema::new;
	public static final DataFixer DATA_FIXER = class_156.method_654(new DataFixerBuilder(RIFT_DATA_VERSION), builder -> {
		builder.addSchema(1, Schema1::new);
		// TODO: add schemas if schema changes
	}).buildUnoptimized();

	public static class_2487 update(int oldVersion, class_2487 original) {
		return (class_2487) DATA_FIXER.update(RIFT_DATA_TYPE_REF, new Dynamic<>( class_2509.field_11560, original), oldVersion, RIFT_DATA_VERSION).getValue();
	}
}
