package org.dimdev.dimdoors.world.pocket;

import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import java.util.List;
import java.util.Optional;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.Executor;
import net.minecraft.class_1966;
import net.minecraft.class_2338;
import net.minecraft.class_2378;
import net.minecraft.class_2680;
import net.minecraft.class_2791;
import net.minecraft.class_2794;
import net.minecraft.class_2893;
import net.minecraft.class_2902;
import net.minecraft.class_3233;
import net.minecraft.class_3485;
import net.minecraft.class_4543;
import net.minecraft.class_4966;
import net.minecraft.class_5138;
import net.minecraft.class_5281;
import net.minecraft.class_5455;
import net.minecraft.class_5539;
import net.minecraft.class_6748;
import net.minecraft.class_7059;
import net.minecraft.class_7138;

public class BlankChunkGenerator extends class_2794 {
	public static final Codec<BlankChunkGenerator> CODEC = RecordCodecBuilder.create((instance) ->
			class_2794.method_41042(instance).and(
					class_1966.field_24713.fieldOf("biome_source")
							.forGetter((generator) -> generator.field_12761)
			).apply(instance, instance.stable(BlankChunkGenerator::of))
	);

	private static BlankChunkGenerator of(class_2378<class_7059> structureSets, class_1966 biomeSource) {
		return new BlankChunkGenerator(structureSets, biomeSource);
	}

	private BlankChunkGenerator(class_2378<class_7059> structureSets, class_1966 biomeSource) {
		super(structureSets, Optional.empty(), biomeSource);
	}

	@Override
	public Codec<? extends class_2794> method_28506() {
		return field_24746;
	}

//	@Override
//	public ChunkGenerator withSeed(long seed) {
//		return this;
//	}
//
//	@Override
//	public MultiNoiseUtil.MultiNoiseSampler getMultiNoiseSampler() {
//		return null;
//	}

	@Override
	public void method_12108(class_3233 chunkRegion, long seed, class_7138 noiseConfig, class_4543 world, class_5138 structureAccessor, class_2791 chunk, class_2893.class_2894 carverStep) {
	}

	@Override
	public void method_12110(class_3233 region, class_5138 structures, class_7138 noiseConfig, class_2791 chunk) {
	}

	@Override
	public void method_12107(class_3233 region) {

	}

	@Override
	public int method_12104() {
		return 0;
	}

	@Override
	public void method_16129(class_5455 registryManager, class_7138 noiseConfig, class_5138 structureAccessor, class_2791 chunk, class_3485 structureTemplateManager, long seed) {
	}

	@Override
	public void method_16130(class_5281 structureWorldAccess, class_5138 accessor, class_2791 chunk) {
	}

	@Override
	public CompletableFuture<class_2791> method_12088(Executor executor, class_6748 blender, class_7138 noiseConfig, class_5138 structureAccessor, class_2791 chunk) {
		return CompletableFuture.supplyAsync(() -> chunk);
	}

	@Override
	public int method_16398() {
		return 0;
	}

	@Override
	public int method_33730() {
		return 0;
	}

	@Override
	public int method_16397(int x, int z, class_2902.class_2903 heightmap, class_5539 world, class_7138 noiseConfig) {
		return 0;
	}

	@Override
	public class_4966 method_26261(int x, int z, class_5539 world, class_7138 noiseConfig) {
		return new class_4966(0, new class_2680[0]);
	}

	@Override
	public void method_40450(List<String> text, class_7138 noiseConfig, class_2338 pos) {
	}
}
