package org.dimdev.dimdoors.world.pocket.type;

import com.mojang.serialization.Codec;
import net.minecraft.class_1767;

public enum PocketColor {
	WHITE(0, class_1767.field_7952),
	ORANGE(1, class_1767.field_7946),
	MAGENTA(2, class_1767.field_7958),
	LIGHT_BLUE(3, class_1767.field_7951),
	YELLOW(4, class_1767.field_7947),
	LIME(5, class_1767.field_7961),
	PINK(6, class_1767.field_7954),
	GRAY(7, class_1767.field_7944),
	LIGHT_GRAY(8, class_1767.field_7967),
	CYAN(9, class_1767.field_7955),
	PURPLE(10, class_1767.field_7945),
	BLUE(11, class_1767.field_7966),
	BROWN(12, class_1767.field_7957),
	GREEN(13, class_1767.field_7942),
	RED(14, class_1767.field_7964),
	BLACK(15, class_1767.field_7963),
	NONE(16, null);

	private final int id;
	private final class_1767 color;

	public static Codec<PocketColor> CODEC = Codec.INT.xmap(PocketColor::from, PocketColor::getId);

	PocketColor(int id, class_1767 color) {
		this.id = id;
		this.color = color;
	}

	public class_1767 getColor() {
		return this.color;
	}

	public Integer getId() {
		return this.id;
	}

	public static PocketColor from(class_1767 color) {
		for (PocketColor a : PocketColor.values()) {
			if (color == a.color) {
				return a;
			}
		}

		return NONE;
	}

	public static PocketColor from(int id) {
		for (PocketColor a : PocketColor.values()) {
			if (id == a.id) {
				return a;
			}
		}

		return NONE;
	}
}
