package org.dimdev.dimdoors.world.pocket.type.addon;

import net.minecraft.class_2960;
import org.dimdev.dimdoors.world.pocket.type.Pocket;

public interface AddonProvider {
	<C extends PocketAddon> C getAddon(class_2960 id);

	boolean hasAddon(class_2960 id);

	<C extends PocketAddon> boolean addAddon(C addon);

	default void ensureIsPocket() {
		if (! (this instanceof Pocket)) throw new UnsupportedOperationException("Cannot apply pocket addons to non Pocket Object.");
	}
}
