package org.dimdev.dimdoors.world.pocket.type.addon;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.class_2540;

public interface AutoSyncedAddon extends PocketAddon {
	static <T extends AutoSyncedAddon> List<T> readAutoSyncedAddonList(class_2540 buf) throws IOException {
		List<T> addons = new ArrayList<>();
		int addonCount = buf.readInt();
		try {
			for (int i = 0; i < addonCount; i++) {
				addons.add((T) ((AutoSyncedAddon) PocketAddon.REGISTRY.method_10223(buf.method_10810()).instance()).read(buf));
			}
		} catch (NullPointerException e) {
			throw new IOException(e);
		}
		return addons;
	}

	static class_2540 writeAutoSyncedAddonList(class_2540 buf, List<? extends AutoSyncedAddon> addons) throws IOException {
		buf.writeInt(addons.size());
		for (AutoSyncedAddon addon : addons) {
			buf.method_10812(addon.getType().identifier());
			addon.write(buf);
		}
		return buf;
	}

	// you can generally use PacketByteBuf#readCompoundTag for reading
	AutoSyncedAddon read(class_2540 buf) throws IOException;

	// you can generally use PacketByteBuf#writeCompoundTag for writing
	class_2540 write(class_2540 buf) throws IOException;
}
