package org.dimdev.dimdoors.world.pocket.type.addon;

import net.fabricmc.fabric.api.event.player.AttackBlockCallback;
import net.fabricmc.fabric.api.event.player.PlayerBlockBreakEvents;
import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_1657;
import net.minecraft.class_1747;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2487;
import net.minecraft.class_2540;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import net.minecraft.class_3965;
import org.dimdev.dimdoors.api.event.UseItemOnBlockCallback;
import org.dimdev.dimdoors.world.pocket.type.Pocket;

import java.io.IOException;

public class PreventBlockModificationAddon implements AutoSyncedAddon, AttackBlockCallback, PlayerBlockBreakEvents.Before, UseItemOnBlockCallback {
	public static class_2960 ID = new class_2960("dimdoors", "prevent_block_modification");

	//AttackBlockCallback
	@Override
	public class_1269 interact(class_1657 player, class_1937 world, class_1268 hand, class_2338 pos, class_2350 direction) {
		if (player.method_7337()) return class_1269.field_5811;
		return class_1269.field_5814;
	}

	@Override
	public boolean beforeBlockBreak(class_1937 world, class_1657 player, class_2338 pos, class_2680 state, class_2586 blockEntity) {
		if (player.method_7337()) return true;
		return false;
	}

	@Override
	public class_1269 useItemOnBlock(class_1657 player, class_1937 world, class_1268 hand, class_3965 hitResult) {
		if (player.method_7337()) return class_1269.field_5811;
		if (player.method_5998(hand).method_7909() instanceof class_1747) {
			class_2338 blockPos = hitResult.method_17777();
			class_2680 blockState = world.method_8320(blockPos);
			class_1269 result = blockState.method_26174(world, player, hand, hitResult);
			if (result.method_23665()) return result;

			return class_1269.field_5814;
		}
		return class_1269.field_5811;
	}

	@Override
	public AutoSyncedAddon read(class_2540 buf) throws IOException {
		return this;
	}

	@Override
	public class_2540 write(class_2540 buf) throws IOException {
		return buf;
	}

	@Override
	public PocketAddon fromNbt(class_2487 nbt) {
		return this;
	}

	@Override
	public PocketAddonType<? extends PocketAddon> getType() {
		return PocketAddonType.PREVENT_BLOCK_MODIFICATION_ADDON;
	}

	@Override
	public class_2960 getId() {
		return ID;
	}

	public static class PreventBlockModificationBuilderAddon implements PocketBuilderAddon<PreventBlockModificationAddon> {

		@Override
		public void apply(Pocket pocket) {
			pocket.addAddon(new PreventBlockModificationAddon());
		}

		@Override
		public class_2960 getId() {
			return ID;
		}

		@Override
		public PocketBuilderAddon<PreventBlockModificationAddon> fromNbt(class_2487 nbt) {
			return this;
		}

		@Override
		public PocketAddonType<PreventBlockModificationAddon> getType() {
			return PocketAddonType.PREVENT_BLOCK_MODIFICATION_ADDON;
		}
	}
}
