package org.dimdev.dimdoors.api.util;

import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_5321;

public class RotatedLocation extends Location {
	public final float yaw;
	public final float pitch;

	public RotatedLocation(class_5321<class_1937> world, class_2338 pos, float yaw, float pitch) {
		super(world, pos);
		this.yaw = yaw;
		this.pitch = pitch;
	}

	public static class_2487 serialize(RotatedLocation location) {
		class_2487 nbt = new class_2487();
		nbt.method_10582("world", location.world.method_29177().toString());
		nbt.method_10539("pos", new int[]{location.getX(), location.getY(), location.getZ()});
		nbt.method_10548("yaw", location.pitch);
		nbt.method_10548("pitch", location.pitch);
		return nbt;
	}

	public static RotatedLocation deserialize(class_2487 nbt) {
		int[] pos = nbt.method_10561("pos");
		return new RotatedLocation(
				class_5321.method_29179(class_2378.field_25298, new class_2960(nbt.method_10558("world"))),
				new class_2338(pos[0], pos[1], pos[2]),
				nbt.method_10583("yaw"),
				nbt.method_10583("pitch")
		);
	}
}
