package org.dimdev.dimdoors.block;

import net.minecraft.class_1297;
import net.minecraft.class_1657;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2404;
import net.minecraft.class_243;
import net.minecraft.class_2680;
import org.dimdev.dimdoors.DimensionalDoorsInitializer;
import org.dimdev.dimdoors.entity.limbo.LimboExitReason;
import org.dimdev.dimdoors.fluid.ModFluids;
import org.dimdev.dimdoors.api.rift.target.EntityTarget;
import org.dimdev.dimdoors.rift.targets.EscapeTarget;
import org.dimdev.dimdoors.api.util.math.MathUtil;

public class EternalFluidBlock extends class_2404 {
	private static final EntityTarget TARGET = new EscapeTarget(true);

	public EternalFluidBlock(class_2248.Settings settings) {
		super(ModFluids.ETERNAL_FLUID, settings);
	}

	@Override
	public void method_9548(class_2680 blockState, class_1937 world, class_2338 blockPos, class_1297 entity) {
		if (world.field_9236) {
			return;
		}

		try {
			if (TARGET.receiveEntity(entity, class_243.field_1353, MathUtil.entityEulerAngle(entity), entity.method_18798())) {
				if (entity instanceof class_1657) {
					LimboExitReason.ETERNAL_FLUID.broadcast((class_1657) entity);
				}
			}
		} catch (Throwable e) {
			e.printStackTrace();
		}
	}
}
