package org.dimdev.dimdoors.block.door.data.condition;

import com.google.gson.JsonObject;
import net.minecraft.class_1937;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import org.dimdev.dimdoors.block.entity.EntranceRiftBlockEntity;

public record WorldMatchCondition(class_5321<class_1937> world) implements Condition {
	public static WorldMatchCondition fromJson(JsonObject json) {
		class_5321<class_1937> key = class_5321.method_29179(class_2378.field_25298, new class_2960(json.getAsJsonPrimitive("world").getAsString()));
		return new WorldMatchCondition(key);
	}

	@Override
	public boolean matches(EntranceRiftBlockEntity rift) {
		//noinspection ConstantConditions
		return rift.method_10997().method_27983() == this.world;
	}

	@Override
	public void toJsonInner(JsonObject json) {
		json.addProperty("world", world.method_29177().toString());
	}

	@Override
	public ConditionType<?> getType() {
		return ConditionType.WORLD_MATCH;
	}
}
