package org.dimdev.dimdoors.client;

import org.dimdev.dimdoors.entity.MonolithEntity;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_4587;
import net.minecraft.class_4588;
import net.minecraft.class_5603;
import net.minecraft.class_5606;
import net.minecraft.class_5607;
import net.minecraft.class_5609;
import net.minecraft.class_5610;
import net.minecraft.class_5617;
import net.minecraft.class_583;
import net.minecraft.class_630;

@Environment(EnvType.CLIENT)
public class MonolithModel extends class_583<MonolithEntity> {
    private final class_630 body;

    public MonolithModel(class_5617.class_5618 context) {
        super(MyRenderLayer::getMonolith);
        this.body = context.method_32167(ModEntityModelLayers.MONOLITH);
    }

    public static class_5607 getTexturedModelData() {
        class_5609 modelData = new class_5609();
        class_5610 modelPartData = modelData.method_32111();
        modelPartData.method_32117("body", class_5606.method_32108().method_32101(0, 0).method_32100(-23.5F, -23.5F, 0, 49.0F, 49.0F, 1.0F, false), class_5603.field_27701);
        return class_5607.method_32110(modelData, 102, 51);
    }

    @Override
    public void method_2828(class_4587 matrixStack, class_4588 consumer, int packedLight, int packedOverlay, float red, float green, float blue, float alpha) {
		matrixStack.method_22903();
		matrixStack.method_22905(3.0625f, 3.0625f, 3.0625f);

		class_4587.class_4665 entry = matrixStack.method_23760();

		consumer.method_22918(entry.method_23761(), -1, -0.5f, 0)
				.method_22915(red, green, blue, alpha)
				.method_22913(0,0)
				.method_22922(packedOverlay)
				.method_22916(packedLight)
				.method_23763(entry.method_23762(), 0, 0, 1)
				.method_1344();
		consumer.method_22918(entry.method_23761(), -1, 0.5f, 0)
				.method_22915(red, green, blue, alpha)
				.method_22913(0, 1)
				.method_22922(packedOverlay)
				.method_22916(packedLight)
				.method_23763(entry.method_23762(), 0, 0, 1)
				.method_1344();
		consumer.method_22918(entry.method_23761(), 1, 0.5f, 0)
				.method_22915(red, green, blue, alpha)
				.method_22913(1,1)
				.method_22922(packedOverlay)
				.method_22916(packedLight)
				.method_23763(entry.method_23762(), 0, 0, 1)
				.method_1344();
		consumer.method_22918(entry.method_23761(), 1, -0.5f, 0)
				.method_22915(red, green, blue, alpha)
				.method_22913(1, 0)
				.method_22922(packedOverlay)
				.method_22916(packedLight)
				.method_23763(entry.method_23762(), 0, 0, 1)
				.method_1344();

		matrixStack.method_22909();

//        this.body.render(matrixStack, consumer, packedLight, packedOverlay);
    }

    @Override
    public void setAngles(MonolithEntity entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
        this.body.field_3675 = netHeadYaw * 0.017453292F;
        this.body.field_3654 = headPitch * 0.017453292F;
    }
}
