package org.dimdev.dimdoors.client;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.fabricmc.fabric.api.client.rendering.v1.BuiltinItemRendererRegistry;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_310;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_809;
import net.minecraft.class_918;
import org.dimdev.dimdoors.item.DimensionalDoorItemRegistrar;

@Environment(EnvType.CLIENT)
public class UnderlaidChildItemRenderer implements BuiltinItemRendererRegistry.DynamicItemRenderer {
	private final class_1799 underlay;

	public UnderlaidChildItemRenderer(class_1792 underlay) {
		this.underlay = new class_1799(underlay);
	}

	public UnderlaidChildItemRenderer(class_1799 underlay) {
		this.underlay = underlay;
	}

	@Override
	public void render(class_1799 stack, class_809.class_811 mode, class_4587 matrices, class_4597 vertexConsumers, int light, int overlay) {
		if (!(stack.method_7909() instanceof DimensionalDoorItemRegistrar.ChildItem)) throw new UnsupportedOperationException("Can only use UnderlaidChildItemRenderer for ChildItems");
		DimensionalDoorItemRegistrar.ChildItem childItem = (DimensionalDoorItemRegistrar.ChildItem) stack.method_7909();

		matrices.method_22903();
		matrices.method_22904(0.5D, 0.5D, 0.5D);

		class_918 itemRenderer = class_310.method_1551().method_1480();

		matrices.method_22903();
		matrices.method_22905(1, 1, 0.5f);
		itemRenderer.method_23178(underlay, class_809.class_811.field_4315, light, overlay, matrices, vertexConsumers, 0);
		matrices.method_22909();

		class_1799 originalItemStack = new class_1799(
				childItem.getOriginalItem(),
				stack.method_7947());
		originalItemStack.method_7980(stack.method_7969());

		matrices.method_22903();
		childItem.transform(matrices);
		itemRenderer.method_23178(originalItemStack, class_809.class_811.field_4315, light, overlay, matrices, vertexConsumers, 0);
		matrices.method_22909();

		matrices.method_22909();
	}
}
