package org.dimdev.dimdoors.item;

import net.minecraft.class_1304;
import net.minecraft.class_1741;
import net.minecraft.class_1856;
import net.minecraft.class_3414;
import net.minecraft.class_3417;
import net.minecraft.class_3528;

public enum ModArmorMaterials implements class_1741 {
	WORLD_THREAD(5, 15, class_3417.field_14581, new class_3528<>(() -> class_1856.method_8091(ModItems.WORLD_THREAD)), "world_thread", new int[]{1, 2, 3, 1}, 0.0F, 0.0F);

	private static final int[] BASE_DURABILITY = new int[]{13, 15, 16, 11};
	private final int durabilityMultiplier;
	private final int enchantability;
	private final class_3414 equipSound;
	private final class_3528<class_1856> repairIngredient;
	private final String name;
	private final int[] protectionAmounts;
	private final float toughness;
	private final float knockbackResistance;

	ModArmorMaterials(int durabilityMultiplier, int enchantability, class_3414 equipSound, class_3528<class_1856> repairIngredient, String name, int[] protectionAmounts, float toughness, float knockbackResistance) {
		this.durabilityMultiplier = durabilityMultiplier;
		this.enchantability = enchantability;
		this.equipSound = equipSound;
		this.repairIngredient = repairIngredient;
		this.name = name;
		this.protectionAmounts = protectionAmounts;
		this.toughness = toughness;
		this.knockbackResistance = knockbackResistance;
	}

	@Override
	public int method_7696(class_1304 slot) {
		return BASE_DURABILITY[slot.method_5927()] * this.durabilityMultiplier;
	}

	@Override
	public int method_7697(class_1304 slot) {
		return this.protectionAmounts[slot.method_5927()];
	}

	@Override
	public int method_7699() {
		return this.enchantability;
	}

	@Override
	public class_3414 method_7698() {
		return this.equipSound;
	}

	@Override
	public class_1856 method_7695() {
		return this.repairIngredient.method_15332();
	}

	@Override
	public String method_7694() {
		return this.name;
	}

	@Override
	public float method_7700() {
		return this.toughness;
	}

	@Override
	public float method_24355() {
		return this.knockbackResistance;
	}
}
