package org.dimdev.dimdoors.listener;

import net.fabricmc.fabric.api.event.lifecycle.v1.ServerChunkEvents;
import net.minecraft.class_2818;
import net.minecraft.class_3218;
import org.dimdev.dimdoors.pockets.generator.LazyPocketGenerator;
import org.dimdev.dimdoors.pockets.modifier.LazyCompatibleModifier;
import org.dimdev.dimdoors.world.ModDimensions;
import org.dimdev.dimdoors.world.level.registry.DimensionalRegistry;
import org.dimdev.dimdoors.world.pocket.type.LazyGenerationPocket;
import org.dimdev.dimdoors.world.pocket.type.Pocket;

public class ChunkLoadListener implements ServerChunkEvents.Load {
	@Override
	public void onChunkLoad(class_3218 world, class_2818 chunk) {
		if (!ModDimensions.isPocketDimension(world)) return;
		Pocket pocket = DimensionalRegistry.getPocketDirectory(world.method_27983()).getPocketAt(chunk.method_12004().method_8323());
		if (!(pocket instanceof LazyGenerationPocket)) return;
		if (LazyPocketGenerator.currentlyGenerating) {
			LazyPocketGenerator.generationQueue.add(chunk);
		} else {
			LazyCompatibleModifier.runQueuedModifications(chunk);
			((LazyGenerationPocket) pocket).chunkLoaded(chunk);
		}
	}
}
