package org.dimdev.dimdoors.listener.pocket;

import net.fabricmc.fabric.api.event.player.PlayerBlockBreakEvents;
import net.minecraft.class_1657;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import java.util.List;

public class PlayerBlockBreakEventBeforeListener implements PlayerBlockBreakEvents.Before {
	@Override
	public boolean beforeBlockBreak(class_1937 world, class_1657 player, class_2338 pos, class_2680 state, class_2586 blockEntity) {
		List<PlayerBlockBreakEvents.Before> applicableAddons;
		if (world.field_9236) applicableAddons = PocketListenerUtil.applicableAddonsClient(PlayerBlockBreakEvents.Before.class, world, player.method_24515());
		else applicableAddons = PocketListenerUtil.applicableAddons(PlayerBlockBreakEvents.Before.class, world, player.method_24515());

		for (PlayerBlockBreakEvents.Before listener : applicableAddons) {
			if (!listener.beforeBlockBreak(world, player, pos, state, blockEntity)) return false;
		}
		return true;
	}
}
