package org.dimdev.dimdoors.mixin;

import com.mojang.brigadier.arguments.ArgumentType;
import net.minecraft.class_2314;
import net.minecraft.class_2316;
import net.minecraft.class_2319;
import net.minecraft.class_2378;
import org.dimdev.dimdoors.command.arguments.BlockPlacementTypeArgumentType;
import org.dimdev.dimdoors.command.arguments.PocketTemplateArgumentType;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_2316.class)
public abstract class ArgumentTypesMixin {
	@Shadow
	private static <A extends ArgumentType<?>, T extends class_2314.class_7217<A>> class_2314<A, T> register(class_2378<class_2314<?, ?>> registry, String string, Class<? extends A> clazz, class_2314<A, T> argumentSerializer) {
		throw new AssertionError("Nope.");
	}

	@Inject(method = "register(Lnet/minecraft/util/registry/Registry;)Lnet/minecraft/command/argument/serialize/ArgumentSerializer;", at = @At("RETURN"))
	private static void register(class_2378<class_2314<?, ?>> registry, CallbackInfoReturnable<class_2314<?, ?>> ci) {
		register(registry, "pocket", PocketTemplateArgumentType.class, class_2319.method_41999(PocketTemplateArgumentType::new));
		register(registry, "block_placement_type", BlockPlacementTypeArgumentType.class, class_2319.method_41999(BlockPlacementTypeArgumentType::blockPlacementType));
	}
}
