package org.dimdev.dimdoors.mixin;

import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_238;
import net.minecraft.class_2680;
import net.minecraft.class_2828;
import net.minecraft.class_3222;
import net.minecraft.class_3244;
import org.dimdev.dimdoors.api.block.AfterMoveCollidableBlock;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_3244.class)
public class ServerPlayNetworkHandlerMixin {
	@Shadow
	public class_3222 player;
	@Shadow
	private double lastTickX;
	@Shadow
	private double lastTickY;
	@Shadow
	private double lastTickZ;

	@Inject(method = "onPlayerMove", at = @At("TAIL"))
	protected void checkBlockCollision(class_2828 packet, CallbackInfo ci) {
		// stolen from Entity#checkBlockCollision
		class_238 box = player.method_5829();
		class_2338 blockPos = new class_2338(box.field_1323 + 0.001D, box.field_1322 + 0.001D, box.field_1321 + 0.001D);
		class_2338 blockPos2 = new class_2338(box.field_1320 - 0.001D, box.field_1325 - 0.001D, box.field_1324 - 0.001D);
		if (player.field_6002.method_22343(blockPos, blockPos2)) {
			class_2338.class_2339 mutable = new class_2338.class_2339();

			boolean done = false;
			for(int i = blockPos.method_10263(); i <= blockPos2.method_10263(); ++i) {
				for(int j = blockPos.method_10264(); j <= blockPos2.method_10264(); ++j) {
					for(int k = blockPos.method_10260(); k <= blockPos2.method_10260(); ++k) {
						mutable.method_10103(i, j, k);
						class_2680 blockState = player.field_6002.method_8320(mutable);
						class_2248 block = blockState.method_26204();
						if (block instanceof AfterMoveCollidableBlock && ((AfterMoveCollidableBlock) block).onAfterMovePlayerCollision(blockState, player.method_14220(), mutable, player, player.method_19538().method_1023(lastTickX, lastTickY, lastTickZ)).method_23665()) {
							done = true;
						}
						if (done) {
							break;
						}
					}
					if (done) {
						break;
					}
				}
				if (done) {
					break;
				}
			}
		}

	}
}
