package org.dimdev.dimdoors.mixin;

import org.dimdev.dimdoors.world.decay.LimboDecay;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.util.function.BooleanSupplier;
import net.minecraft.class_3218;

@Mixin(class_3218.class)
public abstract class ServerWorldMixin {

	@Inject(method = "tick(Ljava/util/function/BooleanSupplier;)V", at = @At(target = "Lnet/minecraft/server/world/ServerWorld;fluidTickScheduler:Lnet/minecraft/world/tick/WorldTickScheduler;", value = "FIELD", ordinal = 0, shift = At.Shift.AFTER))
	public void afterScheduledTick(BooleanSupplier shouldKeepTicking, CallbackInfo ci) {
		LimboDecay.tick((class_3218) (Object) this);
	}
}
