package org.dimdev.dimdoors.mixin;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;
import net.minecraft.class_2960;
import net.minecraft.class_3784;
import net.minecraft.class_3785;
import net.minecraft.class_5469;
import com.mojang.datafixers.util.Pair;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.ModifyVariable;

@Mixin(class_3785.class)
public class StructurePoolMixin {
	@Unique
	private static final class_2960 HOUSES_ID = new class_2960("bastion/treasure/extensions/houses");

	@ModifyVariable(method = "<init>(Lnet/minecraft/util/Identifier;Lnet/minecraft/util/Identifier;Ljava/util/List;Lnet/minecraft/structure/pool/StructurePool$Projection;)V", at = @At("HEAD"))
	private static List<Pair<Function<class_3785.class_3786, ? extends class_3784>, Integer>> thing(List<Pair<Function<class_3785.class_3786, ? extends class_3784>, Integer>> list, class_2960 id, class_2960 terminatorsId, List<Pair<Function<class_3785.class_3786, ? extends class_3784>, Integer>> elementCounts, class_3785.class_3786 projection) {
		if (id.equals(HOUSES_ID)) {
			List<Pair<Function<class_3785.class_3786, ? extends class_3784>, Integer>> copy = new ArrayList<>(list);
			copy.add(Pair.of(class_3784.method_30435("dimdoors:bastion/treasure/houses/bastion_gateway", class_5469.field_26276), 1));
			return copy;
		}
		return list;
	}
}
