package org.dimdev.dimdoors.mixin.client;

import net.minecraft.class_1268;
import net.minecraft.class_1269;
import net.minecraft.class_2885;
import net.minecraft.class_310;
import net.minecraft.class_3965;
import net.minecraft.class_636;
import net.minecraft.class_638;
import net.minecraft.class_7204;
import net.minecraft.class_746;
import org.dimdev.dimdoors.api.event.UseItemOnBlockCallback;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_636.class)
public abstract class ClientPlayerInteractionManagerMixin {

	@Shadow
	@Final
	private class_310 client;

	@Shadow
	protected abstract void sendSequencedPacket(class_638 world, class_7204 packetCreator);

	@Inject(method = "interactBlock", cancellable = true, at = @At(value = "NEW", target = "org/apache/commons/lang3/mutable/MutableObject"))
	public void useItemOnBlock(class_746 player, class_1268 hand, class_3965 hitResult, CallbackInfoReturnable<class_1269> info) {
		class_1269 result = UseItemOnBlockCallback.EVENT.invoker().useItemOnBlock(player, client.field_1687, hand, hitResult);
		if (result == class_1269.field_5811) {
			return;
		}
		info.setReturnValue(result);
		info.cancel();
		if (result == class_1269.field_5812) {
			this.sendSequencedPacket(this.client.field_1687, sequence -> new class_2885(hand, hitResult, sequence));
		}
	}
}
