package org.dimdev.dimdoors.network.packet.c2s;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1268;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import org.dimdev.dimdoors.network.ServerPacketListener;
import org.dimdev.dimdoors.network.SimplePacket;

import java.io.IOException;

public class HitBlockWithItemC2SPacket implements SimplePacket<ServerPacketListener> {
	public static final class_2960 ID = new class_2960("dimdoors", "hit_block_with_item");

	private class_1268 hand;
	private class_2338 pos;
	private class_2350 direction;

	public HitBlockWithItemC2SPacket() {
	}

	@Environment(EnvType.CLIENT)
	public HitBlockWithItemC2SPacket(class_1268 hand, class_2338 pos, class_2350 direction) {
		this.hand = hand;
		this.pos = pos;
		this.direction = direction;
	}

	@Override
	public SimplePacket<ServerPacketListener> read(class_2540 buf) throws IOException {
		hand = buf.method_10818(class_1268.class);
		pos = buf.method_10811();
		direction = buf.method_10818(class_2350.class);
		return this;
	}

	@Override
	public class_2540 write(class_2540 buf) throws IOException {
		buf.method_10817(hand);
		buf.method_10807(pos);
		buf.method_10817(direction);
		return buf;
	}

	@Override
	public void apply(ServerPacketListener listener) {
		listener.onAttackBlock(this);
	}

	@Override
	public class_2960 channelId() {
		return ID;
	}

	public class_2338 getPos() {
		return pos;
	}

	public class_2350 getDirection() {
		return direction;
	}

	public class_1268 getHand() {
		return hand;
	}
}
