package org.dimdev.dimdoors.network.packet.s2c;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import org.dimdev.dimdoors.network.client.ClientPacketListener;
import org.dimdev.dimdoors.network.SimplePacket;

import java.io.IOException;

public class PlayerInventorySlotUpdateS2CPacket implements SimplePacket<ClientPacketListener> {
	public static final class_2960 ID = new class_2960("dimdoors:player_inventory_slot_update");

	private int slot;
	private class_1799 stack;

	@Environment(EnvType.CLIENT)
	public PlayerInventorySlotUpdateS2CPacket() {
		this.stack = class_1799.field_8037;
	}

	public PlayerInventorySlotUpdateS2CPacket(int slot, class_1799 stack) {
		this.slot = slot;
		this.stack = stack;
	}

	@Override
	public SimplePacket<ClientPacketListener> read(class_2540 buf) throws IOException {
		slot = buf.readInt();
		stack = buf.method_10819();
		return this;
	}

	@Override
	public class_2540 write(class_2540 buf) throws IOException {
		buf.writeInt(slot);
		buf.method_10793(stack);
		return buf;
	}

	@Override
	public void apply(ClientPacketListener listener) {
		listener.onPlayerInventorySlotUpdate(this);
	}

	@Override
	public class_2960 channelId() {
		return ID;
	}

	public int getSlot() {
		return slot;
	}

	public class_1799 getStack() {
		return stack;
	}
}
