package org.dimdev.dimdoors.network.packet.s2c;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2338;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import org.dimdev.dimdoors.network.SimplePacket;
import org.dimdev.dimdoors.network.client.ClientPacketListener;

import java.io.IOException;

public class RenderBreakBlockS2CPacket implements SimplePacket<ClientPacketListener> {
	public static final class_2960 ID = new class_2960("dimdoors:render_break_block");

	private class_2338 pos;
	private int stage;

	@Environment(EnvType.CLIENT)
	public RenderBreakBlockS2CPacket() {

	}

	public RenderBreakBlockS2CPacket(class_2338 pos, int stage) {
		this.pos = pos;
		this.stage = stage;
	}

	@Override
	public SimplePacket<ClientPacketListener> read(class_2540 buf) throws IOException {
		pos = buf.method_10811();
		stage = buf.readInt();
		return this;
	}

	@Override
	public class_2540 write(class_2540 buf) throws IOException {
		buf.method_10807(pos);
		buf.writeInt(stage);
		return buf;
	}

	@Override
	public void apply(ClientPacketListener listener) {
		listener.onRenderBreakBlock(this);
	}

	@Override
	public class_2960 channelId() {
		return ID;
	}

	public class_2338 getPos() {
		return pos;
	}

	public int getStage() {
		return stage;
	}
}
