package org.dimdev.dimdoors.particle.client;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2400;
import net.minecraft.class_4002;
import net.minecraft.class_4794;
import net.minecraft.class_5819;
import net.minecraft.class_638;
import net.minecraft.class_703;
import net.minecraft.class_707;
import net.minecraft.client.particle.*;

@Environment(EnvType.CLIENT)
public class LimboAshParticle extends class_4794 {

	protected LimboAshParticle(class_638 world, double x, double y, double z, double velocityX, double velocityY, double velocityZ, float scaleMultiplier, class_4002 spriteProvider) {
		super(world, x, y, z, 0.1F, 0.1F, 0.01F, velocityX, velocityY, velocityZ, scaleMultiplier, spriteProvider, 0.0F, 20, 0.0125F, false);
		this.field_3861 = 0.0431F;
		this.field_3842 = 0.0353F;
		this.field_3859 = 0.0352F;
		this.field_3844 = -field_3844;
	}

	@Environment(EnvType.CLIENT)
	public record Factory(class_4002 spriteProvider) implements class_707<class_2400> {
		public class_703 createParticle(class_2400 defaultParticleType, class_638 clientWorld, double d, double e, double f, double g, double h, double i) {
			class_5819 random = clientWorld.field_9229;
			double j = (double) random.method_43057() * 0.4D * (double) random.method_43057() * 0.1D;
			double k = (double) random.method_43057() * 0.8D * (double) random.method_43057() * 0.1D;// * 5.0D;
			double l = (double) random.method_43057() * 0.4D * (double) random.method_43057() * 0.1D;
			return new LimboAshParticle(clientWorld, d, e, f, j, k, l, 1.0F, this.spriteProvider);
		}
	}
}
