package org.dimdev.dimdoors.rift.registry;

import net.minecraft.class_1937;
import net.minecraft.class_2378;
import net.minecraft.class_2487;
import net.minecraft.class_2960;
import net.minecraft.class_5321;

public class PocketEntrancePointer extends RegistryVertex { // TODO: PocketRiftPointer superclass?
	private int pocketId;

	public PocketEntrancePointer(class_5321<class_1937> pocketDim, int pocketId) {
		this.setWorld(pocketDim);
		this.pocketId = pocketId;
	}

	public PocketEntrancePointer() {
	}

	@Override
	public RegistryVertexType<? extends RegistryVertex> getType() {
		return RegistryVertexType.ENTRANCE;
	}

	public String toString() {
		return "PocketEntrancePointer(pocketDim=" + this.getWorld() + ", pocketId=" + this.pocketId + ")";
	}

	public static class_2487 toNbt(PocketEntrancePointer vertex) {
		class_2487 nbt = new class_2487();
		nbt.method_25927("id", vertex.id);
		nbt.method_10582("pocketDim", vertex.getWorld().method_29177().toString());
		nbt.method_10569("pocketId", vertex.pocketId);
		return nbt;
	}

	public static PocketEntrancePointer fromNbt(class_2487 nbt) {
		PocketEntrancePointer pointer = new PocketEntrancePointer(class_5321.method_29179(class_2378.field_25298, new class_2960(nbt.method_10558("pocketDim"))), nbt.method_10550("pocketId"));
		pointer.id = nbt.method_25926("id");
		return pointer;
	}

	public int getPocketId() {
		return pocketId;
	}
}
