package org.dimdev.dimdoors.rift.targets;

import com.mojang.serialization.Codec;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import org.dimdev.dimdoors.api.util.Location;

public class LocalReference extends RiftReference {
	public static final Codec<LocalReference> CODEC = class_2338.field_25064.xmap(LocalReference::new, LocalReference::getTarget).fieldOf("target").codec();

	private final class_2338 target;

	public LocalReference(class_2338 target) {
		this.target = target;
	}

	@Override
	public Location getReferencedLocation() {
		return new Location(this.location.world, this.target);
	}

	public class_2338 getTarget() {
		return this.target;
	}

	@Override
	public VirtualTargetType<? extends VirtualTarget> getType() {
		return VirtualTargetType.LOCAL;
	}

	public static class_2487 toNbt(LocalReference localReference) {
		class_2487 nbt = new class_2487();
		nbt.method_10539("target", new int[]{localReference.target.method_10263(), localReference.target.method_10264(), localReference.target.method_10260()});
		return nbt;
	}

	public static LocalReference fromNbt(class_2487 nbt) {
		int[] pos = nbt.method_10561("target");
		return new LocalReference(
				new class_2338(pos[0], pos[1], pos[2])
		);
	}
}
