package org.dimdev.dimdoors.rift.targets;

import com.mojang.serialization.Codec;
import net.minecraft.class_1297;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import net.minecraft.class_2588;
import net.minecraft.class_5250;
import org.dimdev.dimdoors.api.rift.target.EntityTarget;
import org.dimdev.dimdoors.api.util.EntityUtils;

public class PocketExitMarker extends VirtualTarget implements EntityTarget {
	public static final Codec<PocketExitMarker> CODEC = Codec.unit(PocketExitMarker::new);

	public PocketExitMarker() {
	}

	@Override
	public boolean receiveEntity(class_1297 entity, class_243 relativePos, class_2379 relativeAngle, class_243 relativeVelocity) {
		EntityUtils.chat(entity, class_5250.method_43477(new class_2588("The exit of this dungeon has not been linked. If this is a normally generated pocket, please report this bug.")));
		return false;
	}

	@Override
	public VirtualTargetType<? extends VirtualTarget> getType() {
		return VirtualTargetType.POCKET_EXIT;
	}
}
