package org.dimdev.dimdoors.rift.targets;

import net.minecraft.class_2382;
import net.minecraft.class_2487;
import org.dimdev.dimdoors.api.util.Location;

public class RelativeReference extends RiftReference {
	private final class_2382 offset;

	public RelativeReference(class_2382 offset) {
		this.offset = offset;
	}

	@Override
	public Location getReferencedLocation() {
		return new Location(this.location.world, this.location.pos.method_10081(this.offset));
	}

	public class_2382 getOffset() {
		return this.offset;
	}

	@Override
	public VirtualTargetType<? extends VirtualTarget> getType() {
		return VirtualTargetType.RELATIVE;
	}

	public static class_2487 toNbt(RelativeReference target) {
		class_2487 nbt = new class_2487();
		nbt.method_10539("offset", new int[]{target.offset.method_10263(), target.offset.method_10264(), target.offset.method_10260()});
		return nbt;
	}

	public static RelativeReference fromNbt(class_2487 nbt) {
		int[] offset = nbt.method_10561("offset");
		return new RelativeReference(new class_2382(offset[0], offset[1], offset[2]));
	}
}
