package org.dimdev.dimdoors.rift.targets;

import org.dimdev.dimdoors.api.rift.target.EntityTarget;

import java.util.Collections;
import net.minecraft.class_1297;
import net.minecraft.class_2379;
import net.minecraft.class_243;
import net.minecraft.class_5819;

public class UnstableTarget extends VirtualTarget implements EntityTarget {
	private static final class_5819 RANDOM = class_5819.method_43047();

	@Override
	public VirtualTargetType<? extends VirtualTarget> getType() {
		return VirtualTargetType.UNSTABLE;
	}

	@Override
	public boolean receiveEntity(class_1297 entity, class_243 relativePos, class_2379 relativeAngle, class_243 relativeVelocity) {
		if (RANDOM.method_43056()) {
			return RandomTarget.builder()
					.acceptedGroups(Collections.singleton(0))
					.coordFactor(1)
					.negativeDepthFactor(10000)
					.positiveDepthFactor(80)
					.weightMaximum(100)
					.noLink(false)
					.noLinkBack(false)
					.newRiftWeight(1)
					.build()
					.as(Targets.ENTITY)
					.receiveEntity(entity, relativePos, relativeAngle, relativeVelocity);
		}

		return LimboTarget.INSTANCE.receiveEntity(entity, relativePos, relativeAngle, relativeVelocity);
	}
}
