package org.dimdev.dimdoors.world.decay.processors;

import static org.dimdev.dimdoors.world.decay.DecayProcessor.DecayProcessorType.SELF;

import com.google.gson.JsonObject;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2487;
import net.minecraft.class_2680;
import org.dimdev.dimdoors.world.decay.DecayProcessor;

public class SelfDecayProcessor implements DecayProcessor {
    public static final String KEY = "self";

    private static final SelfDecayProcessor instance = new SelfDecayProcessor();

    public static SelfDecayProcessor instance() {
        return instance;
    }

    @Override
    public DecayProcessor fromNbt(class_2487 nbt) {
        return this;
    }

    @Override
    public DecayProcessorType<? extends DecayProcessor> getType() {
        return SELF;
    }

    @Override
    public String getKey() {
        return KEY;
    }

    @Override
    public int process(class_1937 world, class_2338 pos, class_2680 origin, class_2680 target) {
        world.method_8501(pos, origin);
        return 0;
    }
}
